"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var view_1 = require("@nativescript/core/ui/core/view");
var TNSPath2D_1 = require("../TNSPath2D");
var SVGItem_1 = require("./SVGItem");
var CanvasGradient_1 = require("../CanvasGradient");
exports.dProperty = new view_1.Property({
    name: 'd'
});
var Path = (function (_super) {
    __extends(Path, _super);
    function Path() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Path.prototype.handleValues = function (canvas) {
        var ctx;
        if (canvas) {
            ctx = canvas.getContext('2d');
        }
        else {
            ctx = this._canvas.getContext('2d');
        }
        ctx.save();
        if (this.strokeWidth) {
            ctx.lineWidth = this.strokeWidth;
        }
        ctx.globalAlpha = this._realOpacity;
        var lastOpacity;
        if (this._doFillOpacity()) {
            lastOpacity = ctx.globalAlpha;
            ctx.globalAlpha = this._realFillOpacity;
        }
        var path;
        if (this.d) {
            path = new TNSPath2D_1.TNSPath2D(this.d);
        }
        if (path && this._doFill()) {
            if (this.fill !== undefined && this.fill !== 'none') {
                if (this.fill && this.fill.indexOf('url') > -1) {
                    var fill = this._getViewById(this.fill);
                    if (fill) {
                        var style = fill._getFillOrStrokeStyle();
                        if (style instanceof CanvasGradient_1.CanvasGradient) {
                            ctx.fillStyle = style;
                        }
                        else {
                            ctx.fillStyle = ctx.createPattern(style, 'repeat');
                        }
                    }
                }
                else {
                    ctx.fillStyle = this.fill;
                }
            }
            ctx.fill(path);
        }
        if (lastOpacity !== undefined) {
            ctx.globalAlpha = lastOpacity;
        }
        if (path && this._doStroke()) {
            if (this.stroke !== undefined && this.stroke !== 'none') {
                if (this.stroke && this.stroke.indexOf('url') > -1) {
                    var stroke = this._getViewById(this.stroke);
                    if (stroke) {
                        var style = stroke._getFillOrStrokeStyle();
                        if (style instanceof CanvasGradient_1.CanvasGradient) {
                            ctx.strokeStyle = style;
                        }
                        else {
                            ctx.strokeStyle = ctx.createPattern(style, 'repeat');
                        }
                    }
                }
                else {
                    ctx.strokeStyle = this.stroke;
                }
            }
            ctx.stroke(path);
        }
        ctx.restore();
    };
    return Path;
}(SVGItem_1.SVGItem));
exports.Path = Path;
exports.dProperty.register(Path);
//# sourceMappingURL=Path.js.map