"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var view_1 = require("@nativescript/core/ui/core/view");
var TNSPath2D_1 = require("../TNSPath2D");
var SVGItem_1 = require("./SVGItem");
exports.pointsProperty = new view_1.Property({
    name: 'points'
});
var Polyline = (function (_super) {
    __extends(Polyline, _super);
    function Polyline() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Polyline.prototype.handleValues = function (canvas) {
        var ctx;
        if (canvas) {
            ctx = canvas.getContext('2d');
        }
        else {
            ctx = this._canvas.getContext('2d');
        }
        ctx.save();
        var points;
        if (typeof this.points === 'string') {
            points = this.points.split(' ').map(function (point) {
                if (typeof point === 'string') {
                    var realPoints = point.split(',');
                    var x = parseInt(realPoints[0]);
                    var y = parseInt(realPoints[1]);
                    if (isNaN(x) || isNaN(y)) {
                        return null;
                    }
                    return { x: x, y: y };
                }
                return null;
            }).filter(function (value) {
                return value !== null;
            });
        }
        var path = new TNSPath2D_1.TNSPath2D();
        if (this.strokeWidth !== undefined) {
            ctx.lineWidth = this.strokeWidth;
        }
        if (Array.isArray(points)) {
            points.forEach(function (point, index) {
                if (index === 0) {
                    path.moveTo(point.x, point.y);
                }
                else {
                    path.lineTo(point.x, point.y);
                }
            });
        }
        if (this._doFill()) {
            ctx.fillStyle = this._realFill;
            ctx.fill(path);
        }
        if (this._doStroke()) {
            ctx.strokeStyle = this._realStroke;
            ctx.stroke(path);
        }
        ctx.restore();
    };
    return Polyline;
}(SVGItem_1.SVGItem));
exports.Polyline = Polyline;
exports.pointsProperty.register(Polyline);
//# sourceMappingURL=Polyline.js.map