"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var G_1 = require("./G");
var SVG_1 = require("./SVG");
var SVGItem_1 = require("./SVGItem");
var Symbol_1 = require("./Symbol");
var Circle_1 = require("./Circle");
var Rect_1 = require("./Rect");
var Use = (function (_super) {
    __extends(Use, _super);
    function Use() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.xlink = {};
        _this.width = 0;
        _this.height = 0;
        return _this;
    }
    Use.prototype.handleValues = function (canvas) {
        var _this = this;
        var ctx;
        if (canvas) {
            ctx = canvas.getContext('2d');
        }
        else {
            ctx = this._canvas.getContext('2d');
        }
        var href;
        if (this.xlink && this.xlink.href) {
            href = this.xlink.href;
        }
        if (this.href) {
            href = this.href;
        }
        var svg = this.parent;
        while (!(svg instanceof SVG_1.SVG)) {
            svg = svg.parent;
        }
        if (href && svg instanceof SVG_1.SVG) {
            this.clone = svg._children.get(href.replace('#', ''));
            if (this.clone && this.clone.handleValues) {
                var v = Object.assign(Object.create(Object.getPrototypeOf(this.clone)), this.clone);
                if (v instanceof Circle_1.Circle) {
                    if (this.x !== undefined) {
                        v.cx = this.x;
                    }
                    if (this.y !== undefined) {
                        v.cy = this.y;
                    }
                }
                else if (v instanceof Rect_1.Rect) {
                    if (this.x !== undefined) {
                        v.x = this.x;
                    }
                    if (this.y !== undefined) {
                        v.y = this.y;
                    }
                }
                else if (v instanceof G_1.G || v instanceof Symbol_1.Symbol) {
                    v._views.forEach(function (view) {
                        if (view instanceof Circle_1.Circle) {
                            if (_this.x !== undefined) {
                                view.cx = _this.x;
                            }
                            if (_this.y !== undefined) {
                                view.cy = _this.y;
                            }
                        }
                        else if (view instanceof Rect_1.Rect) {
                            if (_this.x !== undefined) {
                                view.x = _this.x;
                            }
                            if (_this.y !== undefined) {
                                view.y = _this.y;
                            }
                        }
                    });
                }
                v.width = this.width;
                v.height = this.height;
                if (typeof this.opacity === 'number') {
                    v.opacity = this.opacity;
                }
                if (this.fill !== undefined) {
                    v.fill = this.fill;
                }
                if (this.stroke !== undefined) {
                    v.stroke = this.stroke;
                }
                v.strokeWidth = this.strokeWidth;
                v.fillOpacity = this._realFillOpacity;
                v.handleValues();
            }
        }
    };
    return Use;
}(SVGItem_1.SVGItem));
exports.Use = Use;
//# sourceMappingURL=Use.js.map